IT: OTS (China) -0000 #486

v4.0: Create excel+pdf library
09/15/2025 09:40 AM - Xihua Fan

Status: oo0 Start date: 09/05/2025
Priority: aa Due date: 12/01/2025
Assignee: Zhongbao Ye % Done: 100%
Category: Estimated time: 20.00 hours
Target version: v4.0 Spent time: 0.00 hour
Description

Background

1.0000000000excell000 + PDFOO
Task Details

« 1. 00IF00000
o 2 [0IF

v4 coding standard:

1. Gitll
E#Exx(redmine number): xxx(redmine title) - xxx(JO00000)
2.0000
2.1: U00Public -> Protected -> Private
ﬁnzz goooooosex
3. MvcLOvanallil
3.1: v3nv4l000000000000 order.php, order_v3.php
3.2: systemU0000000000000user_v3
- Note: frontll$this->userllv400000$this->customer, Dval0000$this->user
8.3: 000000vanv40000000new User V3

4.0000
tDwig, is, css (s, cssU000000essO0M)

5.0000
l[\l/IVCL (LOenlen)
6.00
1. 000

/**

XXX

@copyright RedBlue-0TS 2024
@version v4

* % X X X

*/

2.00000000 + DOODO

/**

XXX

@param xxx S$xxXx
@param xxxX $xXXx

E I S S S

@return xxx

*/
Output
® Report and Solution

Others

History

#1 - 09/15/2025 12:04 PM - Zhongbao Ye
Output(2025/09/19) 00 + Output(2025/09/15 - 2025/09/16) 11 + Output(2025/09/12 00 - 2025/09/13100)

goog

1. 00pnhpl000000000000DDDOOODDD:
1. PhpSpreadsheet
= doc: https:/phpspreadsheet.readthedocs.io/en/latest/
= repo: https:/github.com/PHPOffice/PhpSpreadsheet
= license: MIT
= composer: https://getcomposer.org/doc/00-intro.md#manual-installation
= version: 5.1
2. mPDF
= doc: https:/mpdf.github.io/
= repo: https:/github.com/mpdf/mpdf
= license: GPL-2.0-only
= composer: https://getcomposer.org/doc/00-intro.md#manual-installation
= version: 8.2
2. DDExceIDDDDPhpExceI aoooo0
3.mpdf 000000000000000000000
o DIR_DOWNLOAD .'custom_declaration/tmp'
40000000
o DIR_DOWNLOAD . custom_declaration/templates/xxxx
5. 000000000
o DIR_DOWNLOAD .'custom_declaration/{year}/{20250916 [l DHL2504662996}/xxxx

Todo:

1.0000000000000A000 [aike-#484
poopoooooooooooooDoD
2. error.log - [ niko #484

2025-09-16 11:17:15 - PHP Warning: Undefined array key 5 in D:\Work\Easytryck\06-Development\ots4d.O-web\w

eb\system\library\PHPOffice\vendor\mpdf\mpdf\src\Mpdf.php on line 20724

2025-09-16 11:17:15 — PHP Warning: Undefined array key 6 in D:\Work\Easytryck\06-Development\ots4.0-web\w

eb\system\library\PHPOffice\vendor\mpdf\mpdf\src\Mpdf.php on line 20724

gpooooooooooooooollocalioooooooooooon

#2 - 09/22/2025 02:40 PM - Zhongbao Ye
- Status changed from 000 to0010
- % Done changed from 40 to 100

#3 - 09/22/2025 02:44 PM - Zhongbao Ye
- Status changed from 0100 to0010
- % Done changed from 100 to 80

#4 - 09/24/2025 10:09 AM - Zhongbao Ye
- Status changed from 000 to0010
- % Done changed from 80 to 100

#5 - 11/25/2025 07:53 PM - Xihua Fan
- Status changed from 000 to000
- % Done changed from 100 to 90

#6 - 12/01/2025 05:59 PM - Zhongbao Ye
https://phpspreadsheet.readthedocs.io/en/latest/
https://github.com/PHPOffice/PhpSpreadsheet
https://getcomposer.org/doc/00-intro.md#manual-installation
https://mpdf.github.io/
https://github.com/mpdf/mpdf
https://getcomposer.org/doc/00-intro.md#manual-installation
https://redmine.easydingzhi.com/issues/484
https://redmine.easydingzhi.com/issues/484

Outupt(2025/12/03) 11 + Outupt(2025/12/01 ~ 2025/12/02) [

1.00 0000000000bug
o Oldl00excel 00000000000000A4 297mm 00000000000
100000000D0000DO000n0000N0O000DO0setHeightl0OOOOODO
o New: 00mpdf 00000000000000y00000
00 contentHeight > imageHeight => yllIll = contentHeight + topMargin - imageHeight
[0 contentHeight < imageHeight => ylllIl = topMargin

2. [0footerl0000000O0D

« (10000000000%0ter00000O00DDO0 = 0O0DODODDOD
« (000000
1. 0000%0oterl
= [J000excellllfooterl0000000000 - 00000mpatl0ntmi00000
- DDDDDPhpSpreadsheet O0footer100000000000class/00 - D000ntmiD000000000ntri0000000000000excell0000
= 000000000000+00ter00000000000000tag: {fixed_footer}
-100000000paf0000000000000+taglO000DO000DO000DOD00D0tag0ONRODOND
Dnﬁn%%ﬂﬂphpexcel.phpﬂDDDDDDDD$properties DDDDDDsheetﬂﬂﬂFixedfooterRowDDDDpdeDDDDMpderiterD
2. html
= J0000AID0000D0O000DO000DOD00D
3.00000
= (0000000000000 = 0000,0000000000000000 < 000000w0DO0DO
= 00000000000000 = 0000
4.000000000 70%000000 O
= (000000 = 0000 - D000 - 00 - 000 00D00hannoonoonnaonoonnaonoon
= 000000000 nvoice/Pcaking list 1000000000000000000000 0
= J0000000000100%0000mvoicelll0100%00000000 - 000scale0000
= [00000000,00000000 - 0000/00000000000000000 - D0scalel
= 0000000+00+, 000scalel000000000/0000000000000000000000000000000000O00000

= 10000000%offset*, 000000O00000D0D0D0DODODODO0DODDofset = 0ODODODOD > 1/20000000 » 0000 = 0.1 : 000D * 0.25;

« 000000
1. Excell0000000sheetl000000FixedFooterRow = footer 000
2.000ppF00 > 100 00 FixedFooterRow > o00000
3.0000000000000 = 0000 + 000

= (000 = 0000297 - 0000 - 0000000000 - 0000;

« (100 = 00000000 - 1/1.180000000 2 0000 =0 - 0000 * 0.25;
4.0000000No0.3 00000000000000FixedFooterRowlOOT footerl000OD
5. Note: 0000sheetl0003000

0000000000 - 0000ooooooooooooa
(00000000footer0 - OOfooter100000000000¢00ter 0000000
Ofooter 0000000000000000000000000000000000%00ter OO

0000o0oooo - oooooood

#7 - 12/01/2025 05:59 PM - Zhongbao Ye

- Due date changed from 09/19/2025 to 12/01/2025
- Status changed from 000 to000

- % Done changed from 90 to 100
http://www.tcpdf.org

